package com.fca.uconnect.global;

import com.amazonaws.services.iot.client.AWSIotException;
import com.amazonaws.services.iot.client.AWSIotMessage;
import com.amazonaws.services.iot.client.AWSIotMqttClient;
import com.amazonaws.services.iot.client.AWSIotQos;
import com.amazonaws.services.iot.client.AWSIotTopic;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectAny;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectMessage;
import com.fca.uconnect.global.GlobalUconnectExtVehSync.VehicleConfigRequest;
import com.google.protobuf.ExtensionRegistry;

public class SDPExampleForVehSync {
private String clientId; // The clientId is unique to the device and obtained from the client X.509 certificate CN.
private int messageId=10; // The messageId is a sequential number incremented and assigned to each message sent from the client.
private AWSIotMqttClient mqttClient; // The mqtt client object from the AWS IoT client library. 
private AWSIotTopic iotTopic; // The Topic object to subscribe for inbound messages.
private ExtensionRegistry extRegistry; // Google protocol buffers extension registry instance.
private int correlationId = 0;// The correlationId is a sender messageId so that Sender can recognize the message once its received response.

public SDPExampleForVehSync() {
	extRegistry = ExtensionRegistry.newInstance();
	extRegistry.add(GlobalUconnectExtVehSync.vehicleConfigPublish);
	extRegistry.add(GlobalUconnectExtVehSync.vehicleConfigRequest);
}

public UconnectMessage getVehicleConfigReqMsg() {
	messageId++;
	VehicleConfigRequest vehReqMsg = VehicleConfigRequest.newBuilder()
			.setConfigSetVersion(1)
			.build();
	UconnectMessage msg = UconnectMessage.newBuilder()
		.setTimestamp(System.currentTimeMillis())
		
		
		.setMessageId(messageId)
		.addMessages(UconnectAny.newBuilder().
		 setExtension(GlobalUconnectExtVehSync.vehicleConfigRequest, vehReqMsg))
		.build();

	return msg;		
}

public void process() {

	mqttClient = new AWSIotMqttClient("endpoint", clientId, "awsAccessKeyId", "awsSecretAccessKey");

try {			
mqttClient.connect();						
 iotTopic = new AWSIotTopic("/VCSC/#",AWSIotQos.QOS1){
	public void onMessage(AWSIotMessage msg) {
try {
	
	UconnectMessage	msgIn = UconnectMessage.parseFrom(msg.getPayload(),extRegistry);			
	if (correlationId==msgIn.getMessageId() &&msgIn.getMessages(0).hasExtension(GlobalUconnectExtVehSync.vehicleConfigPublish) ) {
		GlobalUconnectExtVehSync.VehicleConfigPublish vehPubMsg = msgIn.getMessages(0).getExtension(GlobalUconnectExtVehSync.vehicleConfigPublish);
	// Receive Vehicle Config
	}
	
} catch( Exception ex) {
	ex.printStackTrace();
	System.out.println("Err processing message: "+ex+", try parsing Vehicle Sync.");
}
}
};

mqttClient.subscribe(iotTopic);
sendMessage(getVehicleConfigReqMsg());
} catch (AWSIotException e) {
	System.out.println("Caught Exception "+e);
	e.printStackTrace();
}
}


public void sendMessage(UconnectMessage msg) {
final byte[] msgOut = msg.toByteArray();
new Thread(new Runnable() {

    @Override
public void run() {
try {	
	AWSIotMessage message = new 
			MessagePublisherListener(clientId+"/VCSC/",AWSIotQos.QOS1,msgOut);
	mqttClient.publish(message);

} catch (AWSIotException e) {
	System.out.println("Caught Exception "+e);
				e.printStackTrace();
			}		    	
	    }
	    
	}).start();
}
public static void main(String[] args) {
	SDPExampleForVehSync m = new SDPExampleForVehSync();
	m.process();
}
	
}
